#include <stdio.h>
#include <stdlib.h>
#include "vector.h"

#define M_ROW 10
#define M_COL 20

int main() {
  double *matrix, *vector, *answer;
  int i, j;

  /* init data */
  matrix = (double*)malloc(M_ROW * M_COL * sizeof(double));
  vector = (double*)malloc(M_COL * sizeof(double));
  answer = (double*)malloc(M_ROW * sizeof(double));
 if (matrix == NULL || vector == NULL || answer == NULL) {
    fprintf(stderr, "malloc error\n");
    return 1;
  }
  init_vector(matrix, M_ROW*M_COL, 0);
  init_vector(vector, M_COL, 0);

  /* calc */
  for (i = 0; i < M_ROW; i++) {
    answer[i] = 0;
    for (j = 0; j < M_COL; j++) {
      answer[i] += matrix[M_COL*i+j] * vector[j];
    }
  }

  /* print */
  printf("Matrix\n");
  for (i = 0; i < M_ROW; i++) {
    for (j = 0; j < M_COL; j++) {
      printf("%.0f ", matrix[M_COL*i+j]);
    }
    printf("\n");
  }
  printf("Vector\n");
  for (i = 0; i < M_COL; i++)
    printf("%.0f ", vector[i]);
  printf("\n");
  printf("Answer\n");
  for (i = 0; i < M_COL; i++)
    printf("%.0f ", answer[i]);
  printf("\n");

  free(matrix);
  free(vector);
  free(answer);

  return 0;
}
